<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Crazyflie plugin for ARGoS: src/plugins/robots/crazyflie/simulator/pointmass3d_crazyflie_model.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Crazyflie plugin for ARGoS
   </div>
   <div id="projectbrief">ADARS project -- PCOG / SnT / University of Luxembourg</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_7020b8b7abcceffa3f9f7a2d24718f16.html">plugins</a></li><li class="navelem"><a class="el" href="dir_57fbab4b29583c403f1efb5284ea3eb3.html">robots</a></li><li class="navelem"><a class="el" href="dir_82540c9fcfb987b606f5fb531cb7ce0a.html">crazyflie</a></li><li class="navelem"><a class="el" href="dir_8f67be75dbc917b3ef586b0672f32ede.html">simulator</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pointmass3d_crazyflie_model.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="pointmass3d__crazyflie__model_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef POINTMASS3D_CRAZYFLIE_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define POINTMASS3D_CRAZYFLIE_H</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceargos.html">argos</a> {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;   <span class="keyword">class </span>CPointMass3DEngine;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;   <span class="keyword">class </span>CPointMass3DCrazyflieModel;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;   <span class="keyword">class </span>CQuadRotorEntity;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;}</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;argos3/plugins/simulator/physics_engines/pointmass3d/pointmass3d_model.h&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;argos3/plugins/simulator/entities/quadrotor_entity.h&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;argos3/plugins/robots/crazyflie/simulator/crazyflie_entity.h&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceargos.html">argos</a> {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classargos_1_1CPointMass3DCrazyflieModel.html">   24</a></span>&#160;   <span class="keyword">class </span><a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html">CPointMass3DCrazyflieModel</a> : <span class="keyword">public</span> CPointMass3DModel {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;   <span class="keyword">public</span>:</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;      <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#a0709429a547354eaed64873f6c3e89c9">CPointMass3DCrazyflieModel</a>(CPointMass3DEngine&amp; c_engine,</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                                 <a class="code" href="classargos_1_1CCrazyflieEntity.html">CCrazyflieEntity</a>&amp; c_crazyflie);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classargos_1_1CPointMass3DCrazyflieModel.html#afbc1677f5d939ef52f39b96e9d1c53ae">   31</a></span>&#160;      <span class="keyword">virtual</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#afbc1677f5d939ef52f39b96e9d1c53ae">~CPointMass3DCrazyflieModel</a>() {}</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#ad3b2bdc341fc0c315fef1bf659514497">Reset</a>();</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#a17b4483b0067d4fff8f4bace38f5a851">UpdateFromEntityStatus</a>();</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#a393c962ca8e38b7fbb78b0f797b7e90f">Step</a>();</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#a46024beb8d815252c0d46ab645b7a23f">CalculateBoundingBox</a>();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#a8ac01453e83bda08ae9d171a2f023ed1">CheckIntersectionWithRay</a>(Real&amp; f_t_on_ray,</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                                            <span class="keyword">const</span> CRay3&amp; c_ray) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CPointMass3DCrazyflieModel.html#ab5ebc7528c4c6461e1bc4771c6dc04e5">UpdateOriginAnchor</a>(SAnchor&amp; s_anchor);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;   <span class="keyword">private</span>:</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;      <span class="keywordtype">void</span> UpdateRABAnchor(SAnchor&amp; s_anchor);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;      <span class="keywordtype">void</span> PositionalControl();</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      <span class="keywordtype">void</span> SpeedControl();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      Real PDControl(Real f_cur_error,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;                     Real f_k_p,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                     Real f_k_d,</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                     Real&amp; f_old_error);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;   <span class="keyword">private</span>:</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;      CQuadRotorEntity&amp; m_cQuadRotorEntity;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;      Real m_fBodyHeight;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;      Real m_fArmLength;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;      Real m_fBodyMass;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;      Real m_fBodyInertia;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;      CVector3 m_cPosKP;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;      CVector3 m_cPosKD;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;      Real m_fYawKP;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;      Real m_fYawKD;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;      CVector3 m_cVelKP;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;      CVector3 m_cVelKD;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;      Real m_fRotKP;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;      Real m_fRotKD;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;      CVector3 m_cMaxForce;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;      Real m_fMaxTorque;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;      CQuadRotorEntity::SPositionControlData m_sDesiredPositionData;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;      CQuadRotorEntity::SSpeedControlData m_sDesiredSpeedData;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;      CRadians m_cYaw;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;      CRadians m_cRotSpeed;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      CRadians m_cTorque;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      CVector3 m_cLinearControl;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      Real m_fRotationalControl;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;      Real m_pfLinearError[3];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;      Real m_fRotError;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   };</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;}</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieEntity_html"><div class="ttname"><a href="classargos_1_1CCrazyflieEntity.html">argos::CCrazyflieEntity</a></div><div class="ttdef"><b>Definition:</b> crazyflie_entity.h:27</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html">argos::CPointMass3DCrazyflieModel</a></div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.h:24</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_a0709429a547354eaed64873f6c3e89c9"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#a0709429a547354eaed64873f6c3e89c9">argos::CPointMass3DCrazyflieModel::CPointMass3DCrazyflieModel</a></div><div class="ttdeci">CPointMass3DCrazyflieModel(CPointMass3DEngine &amp;c_engine, CCrazyflieEntity &amp;c_crazyflie)</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:35</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_a17b4483b0067d4fff8f4bace38f5a851"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#a17b4483b0067d4fff8f4bace38f5a851">argos::CPointMass3DCrazyflieModel::UpdateFromEntityStatus</a></div><div class="ttdeci">virtual void UpdateFromEntityStatus()</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:99</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_a393c962ca8e38b7fbb78b0f797b7e90f"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#a393c962ca8e38b7fbb78b0f797b7e90f">argos::CPointMass3DCrazyflieModel::Step</a></div><div class="ttdeci">virtual void Step()</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:109</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_a46024beb8d815252c0d46ab645b7a23f"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#a46024beb8d815252c0d46ab645b7a23f">argos::CPointMass3DCrazyflieModel::CalculateBoundingBox</a></div><div class="ttdeci">virtual void CalculateBoundingBox()</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:157</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_a8ac01453e83bda08ae9d171a2f023ed1"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#a8ac01453e83bda08ae9d171a2f023ed1">argos::CPointMass3DCrazyflieModel::CheckIntersectionWithRay</a></div><div class="ttdeci">virtual bool CheckIntersectionWithRay(Real &amp;f_t_on_ray, const CRay3 &amp;c_ray) const</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:171</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_ab5ebc7528c4c6461e1bc4771c6dc04e5"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#ab5ebc7528c4c6461e1bc4771c6dc04e5">argos::CPointMass3DCrazyflieModel::UpdateOriginAnchor</a></div><div class="ttdeci">virtual void UpdateOriginAnchor(SAnchor &amp;s_anchor)</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:257</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_ad3b2bdc341fc0c315fef1bf659514497"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#ad3b2bdc341fc0c315fef1bf659514497">argos::CPointMass3DCrazyflieModel::Reset</a></div><div class="ttdeci">virtual void Reset()</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.cpp:88</div></div>
<div class="ttc" id="aclassargos_1_1CPointMass3DCrazyflieModel_html_afbc1677f5d939ef52f39b96e9d1c53ae"><div class="ttname"><a href="classargos_1_1CPointMass3DCrazyflieModel.html#afbc1677f5d939ef52f39b96e9d1c53ae">argos::CPointMass3DCrazyflieModel::~CPointMass3DCrazyflieModel</a></div><div class="ttdeci">virtual ~CPointMass3DCrazyflieModel()</div><div class="ttdef"><b>Definition:</b> pointmass3d_crazyflie_model.h:31</div></div>
<div class="ttc" id="anamespaceargos_html"><div class="ttname"><a href="namespaceargos.html">argos</a></div><div class="ttdef"><b>Definition:</b> crazyflie_battery_default_sensor.cpp:16</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
